#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dialog.h>
#include <owl\listbox.h>
#include <owl\dc.h>
#include <string.h>
#include "pr71_1.rc"

//   .
class TWndw: public TFrameWindow
{
  public:
    TWndw(TWindow *parent, const char far *title, TWindow *client); 
    ~TWndw (); 
    void DoSaver();
  protected:
    TPoint mouseXY; 
    int count, cnt;
    TColor *color;

    void GetWindowClass (WNDCLASS &wndClass);
    char far *GetClassName();
    void EvLButtonDown (UINT, TPoint&); 
    void EvMButtonDown (UINT, TPoint&);
    void EvRButtonDown (UINT, TPoint&); 
    void EvMouseMove (UINT, TPoint &point);
    void EvSysCommand (UINT, TPoint&); 
    void EvActivate (UINT, BOOL, HWND); 
    void EvActivateApp (BOOL, HTASK); 
    void EvSysKeyDown (UINT, UINT, UINT); 
    void EvKeyDown (UINT, UINT, UINT);

   DECLARE_RESPONSE_TABLE (TWndw);
};

DEFINE_RESPONSE_TABLE1(TWndw,TFrameWindow)
    EV_WM_LBUTTONDOWN,
    EV_WM_MBUTTONDOWN,
    EV_WM_RBUTTONDOWN,
    EV_WM_MOUSEMOVE,
    EV_WM_SYSCOMMAND,
    EV_WM_ACTIVATE,
    EV_WM_ACTIVATEAPP,
    EV_WM_SYSKEYDOWN,
    EV_WM_KEYDOWN, 
END_RESPONSE_TABLE;

//   .
class TApp: public TApplication 
{
  public:
    TApp() : TApplication() {}
    void InitMainWindow();
  protected:
    TWndw *bubWnd;
    TDialog *dialog;

    BOOL IdleAction (long);
};


//   .
class TDlg : public  TDialog
{
  public:
    TDlg (TWindow *parent, TResId resId);
  protected:
    char LBStrg [10];
    TListBoxData lbData;
    TListBox *listbox;

    void SetupWindow();
    void CmOk();

   DECLARE_RESPONSE_TABLE (TDlg);
};

DEFINE_RESPONSE_TABLE1 (TDlg, TDialog)
  EV_COMMAND (IDOK, CmOk), 
END_RESPONSE_TABLE;

//*****************************
//   TWndw.
//*****************************
// TWndw::TWndw()
//    .
TWndw::TWndw (TWindow *parent, const char far *title,
  TWindow *client):TFrameWindow(parent, title, client) 
{
  //       .
  GetCursorPos(mouseXY);
  ShowCursor(FALSE);
  //   ,   .
  Attr.Style = WS_POPUP;
  Attr.X = 0;
  Attr.Y = 0;
  Attr.W = GetSystemMetrics (SM_CXFULLSCREEN);
  Attr.H = GetSystemMetrics (SM_CYFULLSCREEN) +
			GetSystemMetrics (SM_CYCAPTION);
  //    ,
  //  .
  count = GetPrivateProfileInt ("Screen Saver.Bubbles", "Count", 
           1000, "CONTROL.INI");
  //    .
  randomize();
  //     .
  cnt = 0;
  color = new TColor(random(256), random(256), random(256));
}

// TWndw::TWndw()
//    .
TWndw::~TWndw ()
{
  //   TColor.
  delete color;
  //    .
  ShowCursor(TRUE);
}

// TWndw::GetWindowClass()
//      .
void TWndw::GetWindowClass (WNDCLASS &wndClass)
{
  //   ,     .
  TFrameWindow::GetWindowClass (wndClass);
  //    .
  wndClass.hbrBackground = (HBRUSH) GetStockObject (BLACK_BRUSH);
}

// TWndw::GetClassName()
//      .
char far *TWndw::GetClassName()
{
  return   "BubblesWnd";
}

// TWndw::EvMouseMove()
//      
// ,    
//  WM_MOUSEMOVE.
void TWndw::EvMouseMove(UINT, TPoint& point)
{
  //      ,
  //   .
  if (point != mouseXY) PostMessage(WM_CLOSE);
}

// TWndw::EvLButtonDown()
//      
//   ,    
//  WM_LBUTTONDOWN.
void TWndw::EvLButtonDown(UINT, TPoint&)
{
  //   .
  PostMessage(WM_CLOSE);
}

// TWndw::EvMButtonDown()
//      
//   ,   
//   WM_MBUTTONDOWN.
void TWndw::EvMButtonDown(UINT, TPoint&)
{
  //   .
  PostMessage(WM_CLOSE);
}

// TWndw::EvRButtonDown()
//      
//   ,   
//   WM_RBUTTONDOWN.
void TWndw::EvRButtonDown (UINT, TPoint&)
{
  //   .
  PostMessage(WM_CLOSE);
}

// TWndw::EvActivate()
//      WM_ACTIVATE,
//       .
void TWndw::EvActivate (UINT active, BOOL, HWND)
{
  //     , 
  //  .
  if (!active) PostMessage (WM_CLOSE);
}

// TWndw::EvActivateApp()
//      WM_ACTIVATEAPP,
//      
//   .
void TWndw::EvActivateApp (BOOL active, HTASK)
{
  //    , 
  //  .
  if (!active) PostMessage (WM_CLOSE);
}

// TWndw::EvKeyDown()
//      WM_KEYDOWN,
//  ,   
//   .
void TWndw::EvKeyDown(UINT, UINT, UINT)
{
  //   .
  PostMessage(WM_CLOSE);
}

// TWndw::EvSysKeyDown()
//      WM_SYSKEYDOWN,
//  ,   
//  .
void TWndw::EvSysKeyDown(UINT, UINT, UINT)
{
  //   .
  PostMessage(WM_CLOSE);
}

// TWndw::EvSysCommand()
//     
// WM_SYSCOMMAND, ,    
//     ,    .
void TWndw::EvSysCommand(UINT cmdType, TPoint&)
{
  //     
  // ,  
  //    Windows  .
  if ((cmdType & 0xFFF0) != SC_SCREENSAVE) DefaultProcessing();
}

// TWndw::DoSaver()
//       .
//      ,
//    .
void TWndw::DoSaver()
{
  //   .
  ++cnt;
  //    ,   .
  if (cnt == count)
  {
	 //   .
	 delete color;
	 //   .
	 color = new TColor(random(256), random(256), random(256));
	 //   .
	 cnt = 0;
  }
  //    (DC) 
  //      .
  TBrush brush(*color);
  TClientDC clientDC(HWindow);
  //     .
  clientDC.SelectObject(brush);
  //     .
  int x = random(GetSystemMetrics (SM_CXFULLSCREEN));
  int y = random(GetSystemMetrics (SM_CYFULLSCREEN) +
         GetSystemMetrics (SM_CYCAPTION));
  //   .
  clientDC.Ellipse(x-5, y-5, x+15, y+15);
}

//*****************************
//   TDlg.
//*****************************
// TDlg::TDlg()
//    .
TDlg::TDlg (TWindow *parent, TResId resId):
      TDialog (parent, resId) 
{
  //  OWL-  .
  listbox = new TListBox (this, ID_LISTBOX);
  //    .
  TransferBuffer = &lbData;
}

// TDlg::SetupWindow()
//     
// ,      
//      ,
//     .
void  TDlg::SetupWindow()
{
  //    .
  TDialog::SetupWindow();
  //       . 
  lbData.AddString("1") ; 
  lbData.AddString("10");
  lbData.AddString("100"); 
  lbData.AddString("200"); 
  lbData.AddString("400"); 
  lbData.AddString("1000"); 
  lbData.AddString("2000");
  lbData.AddString("4000");
  //      .
  TransferData(tdSetData);
  //    ,  .
  GetPrivateProfileString("Screen Saver.Bubbles", "Count", 
         "1000", LBStrg, sizeof(LBStrg), "CONTROL.INI");
  //     
  //       . 
  listbox->SetSelString(LBStrg, -1);
}

// TDlg::IdOk()
//      
//  Ok   .  
//      CONTROL.INI.
void TDlg::CmOk()
{
  //     .
  TransferData(tdGetData);
  //   .
  lbData.GetSelString(LBStrg, sizeof(LBStrg));
  //       INI.
  WritePrivateProfileString("Screen Saver.Bubbles", "Count", 
       LBStrg, "CONTROL.INI");
  //   Ok()  , 
  //     .
  TDialog::CmOk();
}

//*****************************
//   TApp.
//*****************************
// TApp::InitMainWindow()
//      .
void TApp::InitMainWindow()
{
  //     .
  bubWnd = NULL;
  //     
  //    , 
  //     .
  char temp[80];
  //  .
  strcpy(temp,_argv[1]);
  if ( ((temp[0] == '/') || (temp[0] == '-')) &&
	  ( (temp[1] == 'c') || (temp[1] == 'C') ))
  {
    dialog = new TDlg(0, DIALOG_1);
    TFrameWindow *wndw = new TFrameWindow (0, 0, dialog, TRUE);
    SetMainWindow(wndw);
  }
  else
  // ...     
  // , ,  ,   
  //  .
  {
    bubWnd = new TWndw(0, 0, 0); 
    SetMainWindow(bubWnd);   
  }
}

// TApp::IdleAction()
//     ,   
//     .
BOOL TApp::IdleAction(long)
{
  //      ,
  //     .
  if (bubWnd)	
  {
    bubWnd->DoSaver();
    return TRUE; 
  } 
  else return FALSE;
}

int OwlMain(int,char *_argv[])
{
  return TApp().Run();
}
